using System;
using SDL2;
using SlatedGameToolkit.Framework.Exceptions;

namespace SlatedGameToolkit.Framework.Graphics.Window
{
    public enum WindowRegion {
        NORMAL = SDL.SDL_HitTestResult.SDL_HITTEST_NORMAL,
        DRAGGABLE = SDL.SDL_HitTestResult.SDL_HITTEST_DRAGGABLE,
        TOP_LEFT = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_TOPLEFT,
        TOP_RIGHT = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_TOPRIGHT,
        BOTTOM_LEFT = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_BOTTOMLEFT,
        BOTTOM_RIGHT = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_BOTTOMRIGHT,
        TOP = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_TOP,
        BOTTOM = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_BOTTOM,
        RIGHT = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_RIGHT,
        LEFT = SDL.SDL_HitTestResult.SDL_HITTEST_RESIZE_LEFT,
    }

    internal static class WindowRegionExtensions {
        public static SDL.SDL_HitTestResult ToSDLHitTestResult(this WindowRegion region) {
            SDL.SDL_HitTestResult result;
            if (!Enum.TryParse(((int) region).ToString(), out result)) throw new InternalFrameworkException("Unable to convert window regions.");
            
            return result;
        }
    }
}