using System;
using SDL2;
using SlatedGameToolkit.Framework.Exceptions;

namespace SlatedGameToolkit.Framework.Graphics.Window
{
    public enum WindowOptions : uint
    {
        HIGH_DPI = SDL.SDL_WindowFlags.SDL_WINDOW_ALLOW_HIGHDPI,
        HIDDEN = SDL.SDL_WindowFlags.SDL_WINDOW_HIDDEN,
    }
    internal static class WindowOptionsExtension {
        public static SDL.SDL_WindowFlags ToSDLWindowFlag(this WindowOptions options) {
            SDL.SDL_WindowFlags sdlFlag;
            if (!(Enum.TryParse(((uint) options).ToString(), out sdlFlag))) throw new InternalFrameworkException("Unable to convert window options.");
            return sdlFlag;
        }
    }
}